"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _chai = require("chai");

var _DocExplorer = require("../DocExplorer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('DocExplorer', function () {
  it('renders spinner when no schema prop is present', function () {
    var W = (0, _enzyme.mount)(_react.default.createElement(_DocExplorer.DocExplorer, null));
    var spinner = W.find('.spinner-container');
    (0, _chai.expect)(spinner.length).to.equal(1);
  });
  it('renders with null schema', function () {
    var W = (0, _enzyme.mount)(_react.default.createElement(_DocExplorer.DocExplorer, {
      schema: null
    }));
    var error = W.find('.error-container');
    (0, _chai.expect)(error.length).to.equal(1);
    (0, _chai.expect)(error.text()).to.equal('No Schema Available');
  });
});